{
	IDLE			[idle]
	WALK			[walk]
	RUN			[run]

	FOV			[160]
	SIGHTDIST		[1000]
	YAWSPEED		[70]
	WALKSPEED		[30]
	SCALE			[1.7]
	DAMAGEATTRIBUTE	[health]
	TELEPORTTARGET	[ScriptPoint9]
	POINTNAME		[abcdefg]

	Start[ ()
	{	
		//Console(true);	
		SetFOV(FOV);					// set field of view
		BoxWidth(50);
		FindTargetOrder(SIGHTDIST, "FoundTarget", DAMAGEATTRIBUTE);	// seen a target to chase
		RotateToPoint(IDLE, YAWSPEED, false, ""); 	// go to point if any specified
		MoveToPoint(WALK, WALKSPEED*SCALE, "");	// move to starting point	
		NewOrder("Guard");
	} ]

	
	Patrol[ ()
	{	
		// patroling from point to point, looking for special orders in each script point (i.e. "Guard")
		NextPoint(); 
		NextOrder();	
		RotateToPoint(IDLE, YAWSPEED, false, "");
		MoveToPoint(WALK, WALKSPEED*SCALE, "");			
		RestartOrder();
	} ]
	
	Guard[()
	{
		// just look around a bit
		Rotate(IDLE, YAWSPEED, 0, -160, 0, "");  
		Delay(IDLE, random(3,5), "");
		Rotate(IDLE, YAWSPEED, 0, 160, 0, "");
		Delay(IDLE, random(3,5), "");
		Align();
		NewOrder("Patrol"); // continue to patrol
	}]
	
	FoundTarget[ ()
	{
		// target discovered
		SetEventState("forbidden", true); // activate trigger to show a message
		SetKeyPause(true); 		// disable keyboard
		RotateToPlayer(IDLE, YAWSPEED, false, "");
		LowLevel("camera");
	}]
	
	camera[()
	{		
		// place the camera behind the pawn so the player can see who found him
		AttachCamera(); 
		TiltCamera(ConvertDegrees(20));
		HighLevel("ViewTarget");
	}]

	ViewTarget[()
	{
		// just look at the player
		Delay(IDLE, 5, "");
		SetEventState("forbidden", false);
		LowLevel("forbidden");
	} ]

	forbidden[()
	{	
		// move pawn and player to TELEPORTTARGET
		TeleportEntity(self.EntityName, TELEPORTTARGET);
		PlayerToPosition(64, 0, 0, false);
		DetachCamera(); // return camera to player
		// name of the 1st scriptpoint in the path is equal to the seven leftmost characters of the pawn's name
		POINTNAME=LeftCopy(self.EntityName, 7); 
		TeleportEntity(self.EntityName, POINTNAME); // move the pawn to the 1st scriptpoint 
		NewPoint(POINTNAME);
		HighLevel("Continue");
	} ]
	
	Continue[()
	{
		SetKeyPause(false); // re-enable keys
		FindTargetOrder(SIGHTDIST, "FoundTarget", DAMAGEATTRIBUTE); // re-activate target order
		NewOrder("Guard"); 
	}]
}

